<?php
/* Joe Presbrey <presbrey@mit.edu>
 * 2007/07/25
 */
require_once('_util.php');

$bin_algae = '/afs/csail.mit.edu/group/dig/www/bin/algae';

if (stristr(get_request_subpath(), '..')) die('Invalid path.');
$request_fullpath = DATA_PATH.DIRECTORY_SEPARATOR.get_request_subpath();
if (($request_realdir = mk_parent_path($request_fullpath))===FALSE) die('Unwritable path.');
if (DATA_PATH != substr($request_realdir, 0, strlen(DATA_PATH))) die('Invalid path.');
$data_file = $request_realdir.DIRECTORY_SEPARATOR.basename($request_fullpath);

//$ext = array_pop(explode('.',basename($data_file)));
//if (!in_array($ext,array('n3','rdf'))) die('Invalid extension.');

$data_uri = sprintf('http://%s%s',$_SERVER['SERVER_NAME'],$_SERVER['REQUEST_URI']);
$tmp_sparql_input = tempnam('/tmp','.sparql');
$tmp_data_output = tempnam('/tmp','.sparql');
$tmp_error_output = tempnam('/tmp','.sparql');

$sparql_input = trim(file_get_contents('php://input'));
$tmp_f = fopen($tmp_sparql_input, 'w+');
fwrite($tmp_f, $sparql_input);
fclose($tmp_f);

//do asynchrnous fetching for the proof here, maybe
//The (temporary) architecture decision made is this:
//data is always saved as RDF/XML with the following untouched code
//(this would reduce unknown bug with algae N3 serializer) 
//and proof are *appended* on existing ones.
//For HTTP GET, if there is no proof in the /meta/ directory the RDF/XML is sent
//if there is proof, then the data is serialized to N3 on GET and combined with
//the proof
if (isset($_SERVER['HTTP_X_META'])) {
  //That's do these routines with the insight from Joe
  $proof_fullpath = DATA_PATH.DIRECTORY_SEPARATOR.'meta'.DIRECTORY_SEPARATOR.get_request_subpath();
  if (($proof_realdir = mk_parent_path($proof_fullpath))===FALSE) die('Unwritable path.');
  if (DATA_PATH != substr($proof_realdir, 0, strlen(DATA_PATH))) die('Invalid path.');
  $proof_path = $proof_realdir.DIRECTORY_SEPARATOR.basename($proof_fullpath);  
  
  $proof_input = "";
  $meta_uri = $_SERVER['HTTP_X_META'];
  if (substr($meta_uri, 0, 4) == "file")         #file:///
    $proof_input = file_get_contents(substr($meta_uri, 7));
  else
    $proof_input = file_get_contents($meta_uri);
  $proof_file = fopen($proof_path, 'a+');
  fwrite($proof_file, $proof_input);
  fclose($proof_file);
 }


$f = fopen(LOG_PATH.DIRECTORY_SEPARATOR.'post_'.date('Y_m_d').'.log', 'a+');
fwrite($f, sprintf("%s %s - [%s] \"%s %s %s\" \"%s\"\n%s\n%s\n",
    $_SERVER['REMOTE_ADDR'],
    $_SERVER['SERVER_NAME'],
    date('d/M/Y:H:i:s O'),
    $_SERVER['REQUEST_METHOD'],
    $_SERVER['REQUEST_URI'],
    $_SERVER['SERVER_PROTOCOL'],
    $_SERVER['HTTP_USER_AGENT'],
    $sparql_input,
    str_repeat('  -', 16)));

if (file_exists($data_file)) {
    $bin_exe = sprintf("$bin_algae -b %s -d $data_file -f $tmp_sparql_input --sClass rdfxml --dump-default >$tmp_data_output 2>$tmp_error_output",
                escapeshellarg($data_uri));
} else {
    $bin_exe = sprintf("$bin_algae -b %s -f $tmp_sparql_input --sClass rdfxml --dump-default >$tmp_data_output 2>$tmp_error_output",
                escapeshellarg($data_uri));
}
`$bin_exe`;

//an RSS folder in the wiki. Everything is this folder should be valid RSS
$bin_cwm = '/afs/csail.mit.edu/group/dig/www/data/TAMI/2007/cwmrete/cwm';
$rss_link_rule = '/afs/csail.mit.edu/group/dig/www/data/2009/tms_web/misc/rss_link_rule.n3';
$is_rss = false;
$rss_folder_name = "rss";
if (substr(get_request_subpath(), 0, strlen($rss_folder_name)) == $rss_folder_name){
  $is_rss = true;
  $tmp_data_output_cwm = tempnam('/tmp','.sparql');
  $bin_exe_cwm = "$bin_cwm --rdf $tmp_data_output --n3 $rss_link_rule --data --apply=$rss_link_rule --rdf>$tmp_data_output_cwm";
  //rss_link_rule is given as data for giving hints of prefixes
  `$bin_exe_cwm`;
  $temp = $tmp_data_output;
  $tmp_data_output = $tmp_data_output_cwm;
 }

fwrite($f, sprintf("%s\n%s\n%s\n",
    $bin_exe,
    file_get_contents($tmp_error_output),
    str_repeat('-', 16*3)));
fclose($f);

if (!filesize($tmp_error_output)) {
    copy($tmp_data_output, $data_file);
    header('MS-Author-Via: SPARQL');
    exit;
} else {
    //exit;
    header('HTTP/1.1 500 Internal Server Error');
    readfile($tmp_error_output);
}

@unlink($tmp_sparql_input);
@unlink($tmp_data_output);
@unlink($tmp_error_output);
if ($is_rss)
  @unlink($temp); //removes the old output from algae
